# Use an official Ubuntu runtime as a base image
FROM ubuntu:20.04

# Let the user tune the available Python versions
# Note: the first version listed here will be the default one
ARG SIMUNE_PYTHON_VERSIONS="3.8.12 3.9.8 3.10.4"

# Adjust system parameters
ENV DEBIAN_FRONTEND="noninteractive"

# Use Bash as default shell for more command-line flexibility
SHELL ["/bin/bash", "-c"]

# Install the required system packages
WORKDIR /root/tmp
COPY packages-system.txt ./
RUN apt-get update -y && \
    apt-get install apt-utils -y && \
    /bin/bash -c "xargs -a <(awk '/^\s*[^#]/' packages-system.txt) -r -- apt-get install -y" && \
    apt-get purge -y *-doc && \
    apt-get clean && \
    rm -rf /var/cache/apt && \
    rm -rf /var/lib/apt/lists/*

# Prepare the environment
RUN echo "C.UTF-8 UTF-8" >/etc/locale.gen && \
    echo "en_US.UTF-8 UTF-8" >>/etc/locale.gen && \
    locale-gen && \
    update-locale LANG="C.UTF-8" && \
    echo "LANG=\"C.UTF-8\"" >/etc/default/locale && \
    echo "LC_ALL=\"C.UTF-8\"" >>/etc/default/locale

# Install the development packages required by pyenv
WORKDIR /root/tmp
COPY packages-pyenv.txt ./
RUN apt-get update -y && \
    /bin/bash -c "xargs -a <(awk '/^\s*[^#]/' packages-pyenv.txt) -r -- apt-get install -y --no-install-recommends" && \
    apt-get purge -y *-doc && \
    apt-get clean && \
    rm -rf /var/cache/apt && \
    rm -rf /var/lib/apt/lists/*

# Install the hypermodern Python environment
WORKDIR /root/tmp
COPY ./install-hypermodern-env.sh ./
RUN /bin/bash ./install-hypermodern-env.sh ${SIMUNE_PYTHON_VERSIONS}

# Make the hypermodern environment loadable
WORKDIR /simune/bin
COPY bin/ ./
RUN chmod u=rw,g=r,o=r ./load-hypermodern-env.sh && \
    chmod u=rwx,g=rx,o=rx ./show-current-env.sh

# Clean-up the mess
WORKDIR /simune
RUN rm -rf /root/tmp

# Open a terminal when the container launches
CMD ["/bin/bash", "-login"]
